@startuml

title CU Net UML Class Diagram


package Compulsary_required <<Frame>> {
  class MX_Controller {
    __constructor()
    __get($class)
  }
  MY_Controller -up-|> CI_Controller

  class MY_Controller {
      +_title
      +_description
      +boolean authenticated_controller
    __constructor()
    +render()
    +logged_in()
    +is_admin()
    -user_id()
    -get_login()
    +valid_form_token()
    +_controller_have_permissions()
  }

  CI -up-|> CI_Controller
  MX_Lang -up-|> CI_Lang
  MX_Loader -up-|> CI_Loader
  MY_Loader -up-|> MX_Loader
  MY_Model -up-|> CI_Model
  MY_Router -up-|> MX_Router
  MX_Router -up-|> CI_Router
  MX_Config -up-|> CI_Config

}
package Model_class <<Folder>> {
    Churches_model -up-|> CI_Model
    class Churches_model {
        +get_churches()
        +get_details()
        +get_church_types()
        +add()
        +update()
        +get_avatar()
        +change_avatar()
        +get_churches_nearby()
        +set_status()
        +set_suggested_by()

    }

    Events_model -up-|> CI_Model
    class Events_model {
        +get_my_events()
        +get_public_events()
        +get_event_details()
        +create_event()
        +update_event()
        +get_event_types()
        +add_invitees()
        +set_invite_status()
        +delete()
        +get_invited()
        +get_all_invited()
        +get_public_event_attendants()
        +get_attending_status()
        +attending_public_event()
        +not_attending_public_event()
        +get_avatar()
        +change_avatar()
    }

    Groups_model -up-|> CI_Model
    class Groups_model{
        +get_active_groups()
        +get_pending_groups()
        +get_all_groups()
        +get_group_details()
        +add_group()
        +update_group()
        +get_group_members()
        +get_group_founder()
        +get_awaiting_memberships()
        +get_group_invited()
        +assign_user_to_group()
        +set_member_role()
        +remove_user_from_group()
        +add_group_invited_members()
        +apply_for_membership()
        +get_invitation_status()
        +get_messages()
        +send_message()
        +delete_message()
        +add_image()
        +get_group_image()
        +delete_image()
        +delete_group()
        +delete_all_group_members()
        +delete_all_group_messages()
        +delete_all_group_invitations()
        +set_search_term()
        +remove_user_invitation()
        +unread_messages_count()
        +mark_messages_as_read()
        +set_group_notifications()
    }

    Messages_model -up-|> MY_Model
    class Messages_model{
        +send_message()
        +add_recipients_to_thread()
        +new_thread_id()
        +get_thread_title()
        +get_all_message_threads()
        +get_unread_message_threads()
        +get_sent_message_threads()
        +search_message_threads()
        +get_all_messages_in_thread()
        +get_all_thread_participants()
        +unread_messages_count()
        +mark_messages_as_read()
        +get_all_thread_recipients()
    }

    Users_model -up-|> CI_Model
    Class Users_model{
        +login()
        +update_last_login_and_password_hash()
        +register_failed_login()
        +get_login_attempts()
        +clear_login_attemprs()
        +get_ip_attempts()
        +register()
        +get_profile()
        +get_public_profile()
        +get_people_in_common()
        +get_people_relations()
        +update_profile()
        +check_username()
        +check_email()
        +check_password()
        +change_password()
        +search_users()
        +add_relation()
        +remove_relation()
        +get_relation()
        +get_connected_relations()
        +get_requested_relations()
        +get_countries()
        +add_password_reset_token()
        +get_password_reset_token()
        +delete_reset_tokens()
        +set_active_status()
        +set_avatar()
        +remove_avatar()
        +get_profile_img()
        +get_people_nearby()

    }
}
package Common_class <<Folder>> {
  Events -up-|> MY_AJAX_Controller
  class Events {
        -__construct()
        +set_status()
        +delete()
        +attending()
        +not_attending()
  }

  groups -up-|> MY_AJAX_Controller
  class groups {
        -__construct()
        +accept_membership()
        +decline_membership()
        +remove_group_member()
        +delete_group()
        +unread_count()
        +toggle_notifications()
        +delete_message()

    }

  Message -up-|> MY_AJAX_Controller
  class Message {
        -__construct()
        +unread_count()
  }

  Profile -up-|> MY_AJAX_Controller
  class Profile {
        -__construct()
        +friend_requests_count()
        +connect_request()
        +friend_disconnect()
  }

  upload -up-|> MY_AJAX_Controller
  class upload {
        -__construct()
        +do_upload()
        +deleteImage()
  }

}


package Libraries_class <<Folder>> {
  MY_AJAX_Controller -up-|> CI_Controller
  class MY_AJAX_Controller {
        -__construct()
        +logged_in()
        +user_id()
        +get_login()
        +return_json()
        +return_html()
    }

  class Assets{
  }
  class Auth{
  }
  class Avatar{
  }
  class Cssmin{
  }
  class Fromtoken{
  }
  class Jsmin{
  }
  class Lang_detect{
  }
}
package Admin_Panel <<Folder>> {

    admin -up-|> MY_Controller
    class admin {
        +boolean authenticated_controller
        +array _allowed_groups
        +index()
    }
    churches -up-|> MY_Controller
    class churches {
        +boolean authenticated_controller
        +array _allowed_groups
        -__construct()
        +index()
    }
    Map -up-|> MY_Controller
    class Map {
        +boolean authenticated_controller
        +array _allowed_groups
        +index()
    }
    Users -up-|> MY_Controller
    class Users {
        +boolean authenticated_controller
        +array _allowed_groups
        -__construct()
        +index()
        +ban()
        +unban()
        +compose()
        +trust()
        +untrust()
    }


    churches2 -up-|> MY_Controller
    class churches2 {
        +boolean authenticated_controller
        +array _allowed_groups
        -__construct()
        +index()
        +details()
        +add()
        +edit()
    }

    Dashboard2 -up-|> MY_Controller
    class Dashboard2 {
        +boolean authenticated_controller
        +array _allowed_groups
        +index()
    }

    events2 -up-|> MY_Controller
    class events2 {
        +boolean authenticated_controller
        +array _allowed_groups
        +index()
        -_preformat_event_date()
        +details()
        +create()
        +edit()
        -notify_invited_to_event_people()

    }

    group2 -up-|> MY_Controller
    class group2 {
        +boolean authenticated_controller
        +array _allowed_groups
        -__construct()
        +view()
        +read()
        -update_group_admins()
        -notify_recipients_for_new_reply()
        -notify_invited_to_group_people()
        -notify_group_founder_for_new_member_request()
        +check_invited()
        -upload_image()
        -resize_image()
        -delete_image()
        +get_group_membership()
        +set_membership_status()
        -mark_messages_as_read()
    }

    Maintenance ---up-|> MY_Controller
    class Maintenance {
        +boolean authenticated_controller
        +index()
    }

    Message2 --up-|> MY_Controller
    class Message2 {
        +boolean authenticated_controller
        -__construct()
        +compose()
        +check_recipients()
        +threads()
        +read()
        -mark_messages_as_read()
        -notify_recipients_for_new_thread()
        -notify_recipients_for_new_reply()

    }

    People --up-|> MY_Controller
    class People {
        +boolean authenticated_controller
        -__construct()
        +index()
        +search()
        +public_profile()

    }

    Profile2 -up-|> MY_Controller
    class Profile2 {
        +boolean authenticated_controller
        -__construct()
        +index()
        +deactivate()

    }
}
package User_Panel <<Folder>> {
    User -up-|> MY_Controller
    class User {
        -__construct()
        +login()
        +logout()
        +register()
        +check_old_password()
        +_send_reset_password_email()
        +reset_password()
        +_valid_token()
        +check_username()
        +check_email()

    }

  note top of Users2 : Original Class Name Is Users.
  Users2 -up-|> MX_Controller
  class Users2 {
        -__construct()
        +get_new_users()
        +release_account_locks()
    }

  note top of church : Original Class Name Is Churches.
  church2 -up-|> MY_Controller
  class church2 {
        -__construct()
        +index()
        +details()
        +add()
        +edit()
    }

    Dashboard -up-|> MY_Controller
    class Dashboard {
        -__construct()
        +index()
        +details()
        +add()
        +edit()
    }

  }



@enduml
